{***************************************************************
 *
 * Unit Name : bench1
 * Purpose   : Disk Benchmark
 * Author    : Eugen Mihailescu
 * Company   : EM Quicksoft Romania SRL
 * Copyright : 1998,2002  All rights reserved.
 * Web Site  : http://www.em-quicksoft.com
 * Support   : support@em-quicksoft.com
 * History   : 03/17/2000
 *
 ****************************************************************}

Unit bench1;
Interface

Uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  FileCtrl,
  ExtCtrls;

Type
  TForm1 = Class(TForm)
    DriveComboBox1: TDriveComboBox;
    Label1: TLabel;
    Button1: TButton;
    Panel1: TPanel;
    Label2: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Panel2: TPanel;
    Label3: TLabel;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    Panel3: TPanel;
    Label4: TLabel;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    Button2: TButton;
    Button3: TButton;
    Label5: TLabel;
    Procedure RadioButton3Click(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure FormDestroy(Sender: TObject);
    Procedure RadioButton2Click(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure RadioButton10Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    Buffer: Pointer;
    BLocksize: Longint;
    Testsize: Longint;
    { Public-Deklarationen }
    Procedure SetBlockSize(I: Longint);
    Procedure StartReadTest;
    Procedure StartWriteTest;
  End;

Var
  Form1             : TForm1;

Implementation

{$R *.DFM}
Uses db02;
//******************* tform1.SetBlockSize *************************

Procedure TForm1.SetBlockSize(I: Longint);
Begin
  Blocksize := I;
End;
//******************* TForm1.RadioButton3Click *************************

Procedure TForm1.RadioButton3Click(Sender: TObject);
Var
  S                 : String;
Begin
  With Sender As tradiobutton Do
    Begin
      S := Caption;
      SetBlockSize(StrToInt(S));
    End;
  Form1.ActiveControl := Button1;
End;
//******************* TForm1.FormCreate *************************

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  GetMem(Buffer, 65536);
  Blocksize := 65536;
  testsize := 10 * 1024 * 1024;
End;
//******************* TForm1.FormDestroy *************************

Procedure TForm1.FormDestroy(Sender: TObject);
Begin
  GetMem(Buffer, 65536);
End;
//******************* TForm1.RadioButton2Click *************************

Procedure TForm1.RadioButton2Click(Sender: TObject);
Var
  S                 : String;
Begin
  With Sender As tradiobutton Do
    Begin
      S := Copy(Caption, 1, 2);
      S := Trim(S);
      Testsize := StrToInt(S) * 1024 * 1024;
    End;
  Form1.ActiveControl := Button1;
End;
//******************* TForm1.Button1Click *************************

Procedure TForm1.Button1Click(Sender: TObject);
Begin
  If radiobutton9.Checked Then
    startReadTest
  Else
    startwritetest;
End;
//******************* RandomName *************************

Function RandomName: AnsiString;
Var
  F                 : Integer;
Begin
  SetLength(Result, 8);
  For F := 1 To 8 Do
    Result[F] := Chr(Random(10) + 48);
  Result := Result + '.TMP';
End;
//******************* TForm1.StartReadTest *************************

Procedure TForm1.StartReadTest;
Var
  written           : Integer;
  Handle            : THandle;
  S                 : AnsiString;
  bps, F, start, stop, startpos, fpos, Numblocks: Longint;

Begin
  S := drivecombobox1.Drive + ':\' + randomname;
  Try

    Handle := CreateFile(
      PChar(S),
      generic_read Or generic_write,
      0,
      Nil,
      CREATE_ALWAYS,
      file_attribute_normal Or
      FILE_FLAG_WRITE_THROUGH Or
      file_flag_sequential_scan Or
      FILE_FLAG_DELETE_ON_CLOSE,
      0);
    If Handle <= 0 Then Raise EInOutError.Create('');

    {Create the file}
    Startpos := testsize - blocksize;
    Numblocks := testsize Div blocksize;

    {Write a single byte to the end of the file (this makes the
     file BIG without the data being in memory cache)           }
    Fpos := SetFilePointer(Handle, StartPos, Nil, file_begin);
    If fpos <> startpos Then Raise EInOutError.Create('');
    If Not WriteFile(Handle, Buffer^, blocksize, written, Nil) Then
      Raise EInOutError.Create('');

    {write data to disk}
    FlushFileBuffers(Handle);

    {seek to start of file}
    Fpos := SetFilePointer(Handle, 0, Nil, file_begin);

    Screen.Cursor := crHourGlass;

    start := GetTickCount;
    For F := 1 To numblocks Do
      If Not ReadFile(Handle, Buffer^, blocksize, written, Nil) Then
        Raise EInOutError.Create('');
    stop := GetTickCount;

    Screen.Cursor := crDefault;
    CloseHandle(Handle);
    Handle := 0;
    Try
      bps := Round((testsize Div ((stop - start))) / 1.024);
      ShowMessage(Format('Read speed is %d kb/sec', [bps]));
    Except
      ShowMessage('Number too big');
    End;
  Except
    ShowMessage('Cannot create file');
    If Handle > 0 Then closehandle(Handle);
  End;
End;
//******************* TForm1.StartWriteTest *************************

Procedure TForm1.StartWriteTest;
Var
  written           : Integer;
  Handle            : THandle;
  S                 : AnsiString;
  bps, F, start, stop, startpos, fpos, Numblocks: Longint;

Begin
  S := drivecombobox1.Drive + ':\' + randomname;
  Try

    Handle := CreateFile(
      PChar(S),
      generic_read Or generic_write,
      0,
      Nil,
      CREATE_ALWAYS,
      file_attribute_normal Or
      {FILE_FLAG_WRITE_THROUGH OR}
      file_flag_random_access Or
      FILE_FLAG_DELETE_ON_CLOSE,
      0);
    If Handle <= 0 Then Raise EInOutError.Create('');

    {Create it with the correct size}
    Startpos := testsize - blocksize;
    Numblocks := testsize Div blocksize;

    Fpos := SetFilePointer(Handle, StartPos, Nil, file_begin);
    If fpos <> startpos Then Raise EInOutError.Create('');

    If Not WriteFile(Handle, Buffer^, blocksize, written, Nil) Then
      Raise EInOutError.Create('');

    FlushFileBuffers(Handle);

    Fpos := SetFilePointer(Handle, 0, Nil, file_begin);

    Screen.Cursor := crHourGlass;

    start := GetTickCount;
    For F := 1 To numblocks Do
      If Not WriteFile(Handle, Buffer^, blocksize, written, Nil) Then
        Raise EInOutError.Create('');
    FlushFileBuffers(Handle);
    stop := GetTickCount;               {wait until file is flushed}

    CloseHandle(Handle);
    Handle := 0;
    Screen.Cursor := crDefault;
    Try
      bps := Round((testsize Div ((stop - start))) / 1.024);
      ShowMessage(Format('Write speed is %d kb/sec', [bps]));
    Except
      ShowMessage('Number too big');
    End;
  Except
    ShowMessage('Cannot create file');
    If Handle > 0 Then closehandle(Handle);
  End;
End;
//******************* TForm1.RadioButton10Click *************************

Procedure TForm1.RadioButton10Click(Sender: TObject);
Begin
  Form1.ActiveControl := Button1;
End;
//******************* TForm1.Button2Click *************************

Procedure TForm1.Button2Click(Sender: TObject);
Var
  X                 : tform2;
Begin
  X := tform2.Create(Self);
  Try
    X.ShowModal;
  Finally
    X.Free;
  End;
End;
//******************* TForm1.Button3Click *************************

Procedure TForm1.Button3Click(Sender: TObject);
Begin
  Close;
End;

End.

